/*
 * Copyright (c) 2001-2023, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH directory.
 */

#define PSM__INTEL_XEON_X5650_12__MVP_HCA_QLGIC_QIB__12PPN                     \
    {{24,                                                                      \
      20,                                                                      \
      {{1, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {2, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {4, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {8, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {16, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {32, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {64, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {128, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {256, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {512, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {1024, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {2048, &MPIR_Allgather_Ring_MVP},                                       \
       {4096, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {8192, &MPIR_Allgather_Ring_MVP},                                       \
       {16384, &MPIR_Allgather_Ring_MVP},                                      \
       {32768, &MPIR_Allgather_Ring_MVP},                                      \
       {65536, &MPIR_Allgather_Ring_MVP},                                      \
       {131072, &MPIR_Allgather_Ring_MVP},                                     \
       {262144, &MPIR_Allgather_Ring_MVP},                                     \
       {524288, &MPIR_Allgather_Ring_MVP},                                     \
       {1048576, &MPIR_Allgather_Ring_MVP}}},                                  \
     {48,                                                                      \
      20,                                                                      \
      {{1, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {2, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {4, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {8, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {16, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {32, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {64, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {128, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {256, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {512, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {1024, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {2048, &MPIR_Allgather_Ring_MVP},                                       \
       {4096, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {8192, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {16384, &MPIR_Allgather_Ring_MVP},                                      \
       {32768, &MPIR_Allgather_Ring_MVP},                                      \
       {65536, &MPIR_Allgather_Ring_MVP},                                      \
       {131072, &MPIR_Allgather_Ring_MVP},                                     \
       {262144, &MPIR_Allgather_Ring_MVP},                                     \
       {524288, &MPIR_Allgather_Ring_MVP},                                     \
       {1048576, &MPIR_Allgather_Ring_MVP}}},                                  \
     {96,                                                                      \
      20,                                                                      \
      {{1, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {2, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {4, &MPIR_Allgather_Bruck_MVP},                                         \
       {8, &MPIR_Allgather_Bruck_MVP},                                         \
       {16, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {32, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {64, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {128, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {256, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {512, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {1024, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {2048, &MPIR_Allgather_Ring_MVP},                                       \
       {4096, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {8192, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {16384, &MPIR_Allgather_Ring_MVP},                                      \
       {32768, &MPIR_Allgather_Ring_MVP},                                      \
       {65536, &MPIR_Allgather_Ring_MVP},                                      \
       {131072, &MPIR_Allgather_Ring_MVP},                                     \
       {262144, &MPIR_Allgather_Ring_MVP},                                     \
       {524288, &MPIR_Allgather_Ring_MVP},                                     \
       {1048576, &MPIR_Allgather_Ring_MVP}}},                                  \
     {192,                                                                     \
      20,                                                                      \
      {{1, &MPIR_Allgather_RD_MVP},                                            \
       {2, &MPIR_Allgather_Bruck_MVP},                                         \
       {4, &MPIR_Allgather_Bruck_MVP},                                         \
       {8, &MPIR_Allgather_Bruck_MVP},                                         \
       {16, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {32, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {64, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {128, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {256, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {512, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {1024, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {2048, &MPIR_Allgather_Ring_MVP},                                       \
       {4096, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {8192, &MPIR_Allgather_Ring_MVP},                                       \
       {16384, &MPIR_Allgather_Ring_MVP},                                      \
       {32768, &MPIR_Allgather_Ring_MVP},                                      \
       {65536, &MPIR_Allgather_Ring_MVP},                                      \
       {131072, &MPIR_Allgather_Ring_MVP},                                     \
       {262144, &MPIR_Allgather_Ring_MVP},                                     \
       {524288, &MPIR_Allgather_Ring_MVP},                                     \
       {1048576, &MPIR_Allgather_Ring_MVP}}},                                  \
     {384,                                                                     \
      20,                                                                      \
      {{1, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {2, &MPIR_Allgather_RD_MVP},                                            \
       {4, &MPIR_Allgather_RD_MVP},                                            \
       {8, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {16, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {32, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {64, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {128, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {256, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {512, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {1024, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {2048, &MPIR_Allgather_Ring_MVP},                                       \
       {4096, &MPIR_Allgather_Ring_MVP},                                       \
       {8192, &MPIR_Allgather_Ring_MVP},                                       \
       {16384, &MPIR_Allgather_Ring_MVP},                                      \
       {32768, &MPIR_Allgather_Ring_MVP},                                      \
       {65536, &MPIR_Allgather_Ring_MVP},                                      \
       {131072, &MPIR_Allgather_Ring_MVP},                                     \
       {262144, &MPIR_Allgather_Ring_MVP},                                     \
       {524288, &MPIR_Allgather_Ring_MVP},                                     \
       {1048576, &MPIR_Allgather_Ring_MVP}}},                                  \
     {768,                                                                     \
      19,                                                                      \
      {{1, &MPIR_Allgather_Bruck_MVP},                                         \
       {2, &MPIR_Allgather_Bruck_MVP},                                         \
       {4, &MPIR_Allgather_Bruck_MVP},                                         \
       {8, &MPIR_Allgather_RD_Allgather_Comm_MVP},                             \
       {16, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {32, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {64, &MPIR_Allgather_RD_Allgather_Comm_MVP},                            \
       {128, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {256, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {512, &MPIR_Allgather_RD_Allgather_Comm_MVP},                           \
       {1024, &MPIR_Allgather_RD_Allgather_Comm_MVP},                          \
       {2048, &MPIR_Allgather_Ring_MVP},                                       \
       {4096, &MPIR_Allgather_Ring_MVP},                                       \
       {8192, &MPIR_Allgather_Ring_MVP},                                       \
       {16384, &MPIR_Allgather_Ring_MVP},                                      \
       {32768, &MPIR_Allgather_Ring_MVP},                                      \
       {65536, &MPIR_Allgather_Ring_MVP},                                      \
       {131072, &MPIR_Allgather_Ring_MVP},                                     \
       {262144, &MPIR_Allgather_Ring_MVP},                                     \
       {524288, &MPIR_Allgather_Ring_MVP}}}};
