/* BEGIN: OSU MVPAICH extension for OPX */

#ifdef HAVE_CH4_NETMOD_OFI

#define MPIDI_OFI_ENABLE_AV_TABLE_OPX              MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_SCALABLE_ENDPOINTS_OPX    MPIDI_OFI_OFF
#define MPIDI_OFI_MAX_ENDPOINTS_OPX                MPIDI_OFI_MAX_ENDPOINTS_REGULAR
#define MPIDI_OFI_MAX_ENDPOINTS_BITS_OPX           MPIDI_OFI_MAX_ENDPOINTS_BITS_REGULAR
#define MPIDI_OFI_ENABLE_SHARED_CONTEXTS_OPX       MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_MR_SCALABLE_OPX           MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_MR_VIRT_ADDRESS_OPX       MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_MR_ALLOCATED_OPX          MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_MR_PROV_KEY_OPX           MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_TAGGED_OPX                MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_RMA_OPX                   MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_AM_OPX                    MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_ATOMICS_OPX               MPIDI_OFI_OFF
#define MPIDI_OFI_FETCH_ATOMIC_IOVECS_OPX          1
#define MPIDI_OFI_ENABLE_DATA_AUTO_PROGRESS_OPX    MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_CONTROL_AUTO_PROGRESS_OPX MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_PT2PT_NOPACK_OPX          MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_HMEM_OPX                  MPIDI_OFI_OFF
#define MPIDI_OFI_NUM_AM_BUFFERS_OPX               MPIDI_OFI_MAX_NUM_AM_BUFFERS
#define MPIDI_OFI_PROTOCOL_MASK_OPX                (0x00E0000000000000ULL)
#define MPIDI_OFI_CONTEXT_MASK_OPX                 (0x000FFFFF00000000ULL)
#define MPIDI_OFI_SOURCE_MASK_OPX                                              \
    (0x0000000000000000ULL) /* We require support for immediate data           \
                             * so this field is zeroed */
#define MPIDI_OFI_TAG_MASK_OPX      (0x000000007FFFFFFFULL)
#define MPIDI_OFI_CONTEXT_BITS_OPX  (20)
#define MPIDI_OFI_SOURCE_BITS_OPX   (0)
#define MPIDI_OFI_TAG_BITS_OPX      (31)
#define MPIDI_OFI_SYNC_SEND_ACK_OPX (0x0010000000000000ULL)
#define MPIDI_OFI_SYNC_SEND_OPX     (0x0020000000000000ULL)
#define MPIDI_OFI_DYNPROC_SEND_OPX  (0x0040000000000000ULL)
#define MPIDI_OFI_HUGE_SEND_OPX     (0x0080000000000000ULL)
#define MPIDI_OFI_MAJOR_VERSION_OPX FI_MAJOR_VERSION
#define MPIDI_OFI_MINOR_VERSION_OPX FI_MINOR_VERSION

#ifdef MPIDI_CH4_OFI_USE_SET_OPX
#define MPIDI_OFI_SET_NUMBER      MPIDI_OFI_SET_NUMBER_OPX
#define MPIDI_OFI_ENABLE_AV_TABLE MPIDI_OFI_ENABLE_AV_TABLE_OPX
#define MPIDI_OFI_ENABLE_SCALABLE_ENDPOINTS                                    \
    MPIDI_OFI_ENABLE_SCALABLE_ENDPOINTS_OPX
#define MPIDI_OFI_MAX_ENDPOINTS      MPIDI_OFI_MAX_ENDPOINTS_OPX
#define MPIDI_OFI_MAX_ENDPOINTS_BITS MPIDI_OFI_MAX_ENDPOINTS_BITS_OPX
#define MPIDI_OFI_ENABLE_SHARED_CONTEXTS                                       \
    MPIDI_OFI_global.settings.enable_shared_contexts /* Always controlled by   \
                                                        CVAR */
#define MPIDI_OFI_ENABLE_MR_SCALABLE     MPIDI_OFI_ENABLE_MR_SCALABLE_OPX
#define MPIDI_OFI_ENABLE_MR_VIRT_ADDRESS MPIDI_OFI_ENABLE_MR_VIRT_ADDRESS_OPX
#define MPIDI_OFI_ENABLE_MR_ALLOCATED    MPIDI_OFI_ENABLE_MR_ALLOCATED_OPX
#define MPIDI_OFI_ENABLE_MR_PROV_KEY     MPIDI_OFI_ENABLE_MR_PROV_KEY_OPX
#define MPIDI_OFI_ENABLE_TAGGED          MPIDI_OFI_ENABLE_TAGGED_OPX
#define MPIDI_OFI_ENABLE_AM              MPIDI_OFI_ENABLE_AM_OPX
#define MPIDI_OFI_ENABLE_RMA             MPIDI_OFI_ENABLE_RMA_OPX
#define MPIDI_OFI_ENABLE_ATOMICS         MPIDI_OFI_ENABLE_ATOMICS_OPX
#define MPIDI_OFI_FETCH_ATOMIC_IOVECS    MPIDI_OFI_FETCH_ATOMIC_IOVECS_OPX
#define MPIDI_OFI_ENABLE_DATA_AUTO_PROGRESS                                    \
    MPIDI_OFI_ENABLE_DATA_AUTO_PROGRESS_OPX
#define MPIDI_OFI_ENABLE_CONTROL_AUTO_PROGRESS                                 \
    MPIDI_OFI_ENABLE_CONTROL_AUTO_PROGRESS_OPX
#define MPIDI_OFI_ENABLE_PT2PT_NOPACK MPIDI_OFI_ENABLE_PT2PT_NOPACK_OPX
#define MPIDI_OFI_ENABLE_HMEM         MPIDI_OFI_ENABLE_HMEM_OPX
#define MPIDI_OFI_NUM_AM_BUFFERS      MPIDI_OFI_NUM_AM_BUFFERS_OPX
#define MPIDI_OFI_PROTOCOL_MASK       (0x00E0000000000000ULL)
#define MPIDI_OFI_CONTEXT_MASK        (0x000FFFFF00000000ULL)
#define MPIDI_OFI_SOURCE_MASK                                                  \
    (0x0000000000000000ULL) /* OPX does support immediate data                 \
                             * so this field is zeroed */
#define MPIDI_OFI_TAG_MASK        (0x000000007FFFFFFFULL)
#define MPIDI_OFI_CONTEXT_BITS    MPIDI_OFI_CONTEXT_BITS_OPX
#define MPIDI_OFI_SOURCE_BITS     MPIDI_OFI_SOURCE_BITS_OPX
#define MPIDI_OFI_TAG_BITS        MPIDI_OFI_TAG_BITS_OPX
#define MPIDI_OFI_SYNC_SEND_ACK   (0x0010000000000000ULL)
#define MPIDI_OFI_SYNC_SEND       (0x0020000000000000ULL)
#define MPIDI_OFI_DYNPROC_SEND    (0x0040000000000000ULL)
#define MPIDI_OFI_HUGE_SEND       (0x0080000000000000ULL)
#define MPIDI_OFI_MAJOR_VERSION   MPIDI_OFI_MAJOR_VERSION_OPX
#define MPIDI_OFI_MINOR_VERSION   MPIDI_OFI_MINOR_VERSION_OPX
#define MPIDI_OFI_CONTEXT_STRUCTS 1
#endif
/* END: MVP OPX extensions */

/* BEGIN: OSU MVPAICH extension for CXI - these are taken from the MPICH
          support patch
*/
#define MPIDI_OFI_ENABLE_AV_TABLE_CXI MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_SCALABLE_ENDPOINTS_CXI                                \
    MPIDI_OFI_OFF /* This is expected to change in                             \
                   * the future. */
#define MPIDI_OFI_MAX_ENDPOINTS_CXI                MPIDI_OFI_MAX_ENDPOINTS_REGULAR
#define MPIDI_OFI_MAX_ENDPOINTS_BITS_CXI           MPIDI_OFI_MAX_ENDPOINTS_BITS_REGULAR
#define MPIDI_OFI_ENABLE_SHARED_CONTEXTS_CXI       MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_MR_VIRT_ADDRESS_CXI       MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_MR_ALLOCATED_CXI          MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_MR_PROV_KEY_CXI           MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_TAGGED_CXI                MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_RMA_CXI                   MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_AM_CXI                    MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_ATOMICS_CXI               MPIDI_OFI_ENABLE_RMA_CXI
#define MPIDI_OFI_FETCH_ATOMIC_IOVECS_CXI          1
#define MPIDI_OFI_ENABLE_DATA_AUTO_PROGRESS_CXI    MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_CONTROL_AUTO_PROGRESS_CXI MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_PT2PT_NOPACK_CXI          MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_HMEM_CXI                  MPIDI_OFI_ON
#define MPIDI_OFI_NUM_AM_BUFFERS_CXI               MPIDI_OFI_MAX_NUM_AM_BUFFERS
#define MPIDI_OFI_NUM_OPTIMIZED_MEMORY_REGIONS     (0)
#define MPIDI_OFI_CONTEXT_BITS_CXI                 (20)
#define MPIDI_OFI_SOURCE_BITS_CXI                  (0)
#define MPIDI_OFI_TAG_BITS_CXI                                                 \
    (20) /* The CXI provider has a smaller tag space                           \
          * than other providers so the number of                              \
          * tag bits exposed to the user is                                    \
          * restricted. This might be expanded                                 \
          * slightly at some point, but it will                                \
          * probably never be the same as some of                              \
          * the other providers. */
#define MPIDI_OFI_COUNTER_WAIT_OBJECTS_CXI MPIDI_OFI_OFF
#define MPIDI_OFI_MAJOR_VERSION_CXI        1
#define MPIDI_OFI_MINOR_VERSION_CXI        5

#ifdef MPIDI_CH4_OFI_USE_SET_CXI
#define MPIDI_OFI_SET_NUMBER      MPIDI_OFI_SET_NUMBER_CXI
#define MPIDI_OFI_ENABLE_AV_TABLE MPIDI_OFI_ENABLE_AV_TABLE_CXI
#define MPIDI_OFI_ENABLE_SCALABLE_ENDPOINTS                                    \
    MPIDI_OFI_ENABLE_SCALABLE_ENDPOINTS_CXI
#define MPIDI_OFI_MAX_ENDPOINTS      MPIDI_OFI_MAX_ENDPOINTS_CXI
#define MPIDI_OFI_MAX_ENDPOINTS_BITS MPIDI_OFI_MAX_ENDPOINTS_BITS_CXI
#define MPIDI_OFI_ENABLE_SHARED_CONTEXTS                                       \
    MPIDI_OFI_global.settings.enable_shared_contexts /* Always controlled by   \
                                                        CVAR */
#define MPIDI_OFI_ENABLE_MR_VIRT_ADDRESS MPIDI_OFI_ENABLE_MR_VIRT_ADDRESS_CXI
#define MPIDI_OFI_ENABLE_MR_ALLOCATED    MPIDI_OFI_ENABLE_MR_ALLOCATED_CXI
#define MPIDI_OFI_ENABLE_MR_PROV_KEY     MPIDI_OFI_ENABLE_MR_PROV_KEY_CXI
#define MPIDI_OFI_ENABLE_TAGGED          MPIDI_OFI_ENABLE_TAGGED_CXI
#define MPIDI_OFI_ENABLE_AM              MPIDI_OFI_ENABLE_AM_CXI
#define MPIDI_OFI_ENABLE_RMA             MPIDI_OFI_ENABLE_RMA_CXI
#define MPIDI_OFI_ENABLE_ATOMICS         MPIDI_OFI_ENABLE_ATOMICS_CXI
#define MPIDI_OFI_FETCH_ATOMIC_IOVECS    MPIDI_OFI_FETCH_ATOMIC_IOVECS_CXI
#define MPIDI_OFI_IOVEC_ALIGN            (1)
#define MPIDI_OFI_ENABLE_DATA_AUTO_PROGRESS                                    \
    MPIDI_OFI_ENABLE_DATA_AUTO_PROGRESS_CXI
#define MPIDI_OFI_ENABLE_CONTROL_AUTO_PROGRESS                                 \
    MPIDI_OFI_ENABLE_CONTROL_AUTO_PROGRESS_CXI
#define MPIDI_OFI_ENABLE_PT2PT_NOPACK MPIDI_OFI_ENABLE_PT2PT_NOPACK_CXI
#define MPIDI_OFI_ENABLE_HMEM         MPIDI_OFI_ENABLE_HMEM_CXI
#define MPIDI_OFI_NUM_AM_BUFFERS      MPIDI_OFI_NUM_AM_BUFFERS_CXI
#define MPIDI_OFI_NUM_OPTIMIZED_MEMORY_REGIONS                                 \
    MPIDI_OFI_NUM_OPTIMIZED_MEMORY_REGIONS_CXI
#define MPIDI_OFI_PROTOCOL_MASK                                                \
    (0x00000E0000000000ULL) /* This is set to 3 (E) even though we actually    \
                             * use 4 (F). The ssend ack bit needs to live      \
                             * outside the protocol bit space to avoid         \
                             * accidentally matching unintended messages.      \
                             * Because of this, we shift the PROTOCOL_MASK one \
                             * extra bit to the                                \
                             * left to take the place of the empty SSEND_ACK   \
                             * bit. */
#define MPIDI_OFI_CONTEXT_MASK (0x000000FFFFF00000ULL)
#define MPIDI_OFI_SOURCE_MASK                                                  \
    (0x0000000000000000ULL) /* CXI does support immediate data so this field   \
                               is zeroed */
#define MPIDI_OFI_TAG_MASK             (0x00000000000FFFFFULL)
#define MPIDI_OFI_CONTEXT_BITS         MPIDI_OFI_CONTEXT_BITS_CXI
#define MPIDI_OFI_SOURCE_BITS          MPIDI_OFI_SOURCE_BITS_CXI
#define MPIDI_OFI_TAG_BITS             MPIDI_OFI_TAG_BITS_CXI
#define MPIDI_OFI_COUNTER_WAIT_OBJECTS MPIDI_OFI_COUNTER_WAIT_OBJECTS_CXI
#define MPIDI_OFI_SYNC_SEND_ACK        (0x0000010000000000ULL)
#define MPIDI_OFI_SYNC_SEND            (0x0000020000000000ULL)
#define MPIDI_OFI_DYNPROC_SEND         (0x0000040000000000ULL)
#define MPIDI_OFI_HUGE_SEND            (0x0000080000000000ULL)
#define MPIDI_OFI_MAJOR_VERSION        MPIDI_OFI_MAJOR_VERSION_CXI
#define MPIDI_OFI_MINOR_VERSION        MPIDI_OFI_MINOR_VERSION_CXI
#define MPIDI_OFI_CONTEXT_STRUCTS      2
#endif
/* END: MVP CXI extensions */

/* BEGIN: OSU MVPAICH extension for PSM 3- these are taken from the MPICH
          support patch in 4.1a
*/
#define MPIDI_OFI_ENABLE_AV_TABLE_PSM3              MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_SCALABLE_ENDPOINTS_PSM3    MPIDI_OFI_ON
#define MPIDI_OFI_MAX_ENDPOINTS_PSM3                MPIDI_OFI_MAX_ENDPOINTS_SCALABLE
#define MPIDI_OFI_MAX_ENDPOINTS_BITS_PSM3           MPIDI_OFI_MAX_ENDPOINTS_BITS_SCALABLE
#define MPIDI_OFI_ENABLE_SHARED_CONTEXTS_PSM3       MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_MR_VIRT_ADDRESS_PSM3       MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_MR_ALLOCATED_PSM3          MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_MR_PROV_KEY_PSM3           MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_TAGGED_PSM3                MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_RMA_PSM3                   MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_AM_PSM3                    MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_ATOMICS_PSM3               MPIDI_OFI_ENABLE_RMA_PSM3
#define MPIDI_OFI_FETCH_ATOMIC_IOVECS_PSM3          1
#define MPIDI_OFI_ENABLE_DATA_AUTO_PROGRESS_PSM3    MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_CONTROL_AUTO_PROGRESS_PSM3 MPIDI_OFI_OFF
#define MPIDI_OFI_ENABLE_PT2PT_NOPACK_PSM3          MPIDI_OFI_ON
#define MPIDI_OFI_ENABLE_HMEM_PSM3                  MPIDI_OFI_OFF
#define MPIDI_OFI_NUM_AM_BUFFERS_PSM3               MPIDI_OFI_MAX_NUM_AM_BUFFERS
#define MPIDI_OFI_CONTEXT_BITS_PSM3                 (20)
#define MPIDI_OFI_SOURCE_BITS_PSM3                  (0)
#define MPIDI_OFI_TAG_BITS_PSM3                     (31)
#define MPIDI_OFI_COUNTER_WAIT_OBJECTS_PSM3         MPIDI_OFI_ON
#define MPIDI_OFI_MAJOR_VERSION_PSM3                1
#define MPIDI_OFI_MINOR_VERSION_PSM3                6

#ifdef MPIDI_CH4_OFI_USE_SET_PSM3
#define MPIDI_OFI_SET_NUMBER      MPIDI_OFI_SET_NUMBER_PSM3
#define MPIDI_OFI_ENABLE_AV_TABLE MPIDI_OFI_ENABLE_AV_TABLE_PSM3
#define MPIDI_OFI_ENABLE_SCALABLE_ENDPOINTS                                    \
    MPIDI_OFI_ENABLE_SCALABLE_ENDPOINTS_PSM3
#define MPIDI_OFI_MAX_ENDPOINTS      MPIDI_OFI_MAX_ENDPOINTS_PSM3
#define MPIDI_OFI_MAX_ENDPOINTS_BITS MPIDI_OFI_MAX_ENDPOINTS_BITS_PSM3
#define MPIDI_OFI_ENABLE_SHARED_CONTEXTS                                       \
    MPIDI_OFI_global.settings.enable_shared_contexts /* Always controlled by   \
                                                        CVAR */
#define MPIDI_OFI_ENABLE_MR_VIRT_ADDRESS MPIDI_OFI_ENABLE_MR_VIRT_ADDRESS_PSM3
#define MPIDI_OFI_ENABLE_MR_ALLOCATED    MPIDI_OFI_ENABLE_MR_ALLOCATED_PSM3
#define MPIDI_OFI_ENABLE_MR_PROV_KEY     MPIDI_OFI_ENABLE_MR_PROV_KEY_PSM3
#define MPIDI_OFI_ENABLE_TAGGED          MPIDI_OFI_ENABLE_TAGGED_PSM3
#define MPIDI_OFI_ENABLE_AM              MPIDI_OFI_ENABLE_AM_PSM3
#define MPIDI_OFI_ENABLE_RMA             MPIDI_OFI_ENABLE_RMA_PSM3
#define MPIDI_OFI_ENABLE_ATOMICS         MPIDI_OFI_ENABLE_ATOMICS_PSM3
#define MPIDI_OFI_FETCH_ATOMIC_IOVECS    MPIDI_OFI_FETCH_ATOMIC_IOVECS_PSM3
#define MPIDI_OFI_ENABLE_DATA_AUTO_PROGRESS                                    \
    MPIDI_OFI_ENABLE_DATA_AUTO_PROGRESS_PSM3
#define MPIDI_OFI_ENABLE_CONTROL_AUTO_PROGRESS                                 \
    MPIDI_OFI_ENABLE_CONTROL_AUTO_PROGRESS_PSM3
#define MPIDI_OFI_ENABLE_PT2PT_NOPACK MPIDI_OFI_ENABLE_PT2PT_NOPACK_PSM3
#define MPIDI_OFI_ENABLE_HMEM         MPIDI_OFI_ENABLE_HMEM_PSM3
#define MPIDI_OFI_NUM_AM_BUFFERS      MPIDI_OFI_NUM_AM_BUFFERS_PSM3
#define MPIDI_OFI_PROTOCOL_MASK       (0x00E0000000000000ULL)
#define MPIDI_OFI_CONTEXT_MASK        (0x000FFFFF00000000ULL)
#define MPIDI_OFI_SOURCE_MASK                                                  \
    (0x0000000000000000ULL) /* PSM3 does support immediate data                \
                             * so this field is zeroed */
#define MPIDI_OFI_TAG_MASK             (0x000000007FFFFFFFULL)
#define MPIDI_OFI_CONTEXT_BITS         MPIDI_OFI_CONTEXT_BITS_PSM3
#define MPIDI_OFI_SOURCE_BITS          MPIDI_OFI_SOURCE_BITS_PSM3
#define MPIDI_OFI_TAG_BITS             MPIDI_OFI_TAG_BITS_PSM3
#define MPIDI_OFI_COUNTER_WAIT_OBJECTS MPIDI_OFI_COUNTER_WAIT_OBJECTS_PSM3
#define MPIDI_OFI_SYNC_SEND_ACK        (0x0010000000000000ULL)
#define MPIDI_OFI_SYNC_SEND            (0x0020000000000000ULL)
#define MPIDI_OFI_DYNPROC_SEND         (0x0040000000000000ULL)
#define MPIDI_OFI_HUGE_SEND            (0x0080000000000000ULL)
#define MPIDI_OFI_MAJOR_VERSION        MPIDI_OFI_MAJOR_VERSION_PSM3
#define MPIDI_OFI_MINOR_VERSION        MPIDI_OFI_MINOR_VERSION_PSM3
#define MPIDI_OFI_CONTEXT_STRUCTS      1
#endif
/* END: MVP PSM3 extensions */

#endif
